#include <allegro5/allegro.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <iostream>
#include <stdio.h>
#include <thread>
#include <ctime>
#include <cstdlib>
#include <string>
#include <allegro5/allegro_native_dialog.h>
#include "Button.cpp"

#define FontFile "Raleway.ttf"
#define DigitFontFile "PTS75F.ttf"

#define NewCarCreationTime 3
#define FreeSpaceToChangeLane 0
#define MinVelocity 2
#define MaxVelocity 5

#define FreeSpaceToAccelerate 5

double SymulationSpeedTab[7] = { 0.04,0.03, 0.02, 0.01, 0.005, 0.003, 0.0025 };
int SymulationSpeedIndex = 3;
double SymulationSpeed = SymulationSpeedTab[SymulationSpeedIndex];

int ThreadOff = 0;
long long int Iteration = 0;
int MaxCarsCount = 0;
int CarsCount = 0;
int *Board[2];
int BlocksCount = 0;
int AnimatonPosY = 325;
int Stop = 0;
int SymulationTime = 0;
int Initialize = 0;
int Zamek = 0;
int BlockCount = 0;

char StatTime[50];
char StatCar[25];
char str2[50];

using namespace std;

int l_pol =2;			// zmienna przechowujaca ilosc  pol tekstowych
int *przelacznik_t;		// wskaznik tablicy dynamicznej przechowujacej wartosci przelacznikow 
string  *pole_t;			// wskaznik tablicy dynamicznej przechowujacej zawartosc pol tekstowych
int *znak_zachety;		// wskaznik tablicy dynamicznej przechowujacej polozenie znakow zachety

ALLEGRO_KEYBOARD_STATE klawiatura;
ALLEGRO_FONT *DigitFont;
ALLEGRO_MOUSE_STATE state;

class CheckMouse
{
public:
	ALLEGRO_FONT *font;
	Button a;
	Button b;
	Button c;
	Button d;
	Button e;

public:
	void CheckButtons()
	{
		al_get_mouse_state(&state);
		if (state.x > a.x1 && state.x<a.x2 && state.y>a.y1 && state.y < a.y2)
		{
			a.Hover = 1;
		}
		else a.Hover = 0;

		if (state.x > b.x1 && state.x<b.x2 && state.y>b.y1 && state.y < b.y2)
		{
			b.Hover = 1;
		}
		else b.Hover = 0;

		if (state.x > c.x1 && state.x<c.x2 && state.y>c.y1 && state.y < c.y2)
		{
			c.Hover = 1;
		}
		else c.Hover = 0;

		if (state.x > d.x1 && state.x<d.x2 && state.y>d.y1 && state.y < d.y2)
		{
			d.Hover = 1;
		}
		else d.Hover = 0;

		if (state.x > e.x1 && state.x<e.x2 && state.y>e.y1 && state.y < e.y2)
		{
			e.Hover = 1;
		}
		else e.Hover = 0;
	}

	CheckMouse(Button aa, Button bb, Button cc, Button dd, Button ee) : a(aa), b(bb), c(cc), d(dd), e(ee) {}
	void operator()()
	{		
		for (;;)
		{
			if (ThreadOff != 1)
			{
				al_get_mouse_state(&state);
				if (state.buttons & 1)
				{
					if (state.x > a.x1 && state.x<a.x2 && state.y>a.y1 && state.y < a.y2)
					{
						Iteration = 0;
						CarsCount = 0;
						SymulationSpeedIndex = 3;
						SymulationSpeed = SymulationSpeedTab[SymulationSpeedIndex];
						Stop = 0;
						Initialize = 1;
					}

					if (state.x > b.x1 && state.x<b.x2 && state.y>b.y1 && state.y < b.y2)
					{
						
						Stop = 1;
					}

					if (state.x > c.x1 && state.x<c.x2 && state.y>c.y1 && state.y < c.y2)
					{
						Stop = 0;

					}

					if (state.x > d.x1 && state.x<d.x2 && state.y>d.y1 && state.y < d.y2)
					{
						if (SymulationSpeedIndex < 6)
						{
							SymulationSpeedIndex++;
							SymulationSpeed = SymulationSpeedTab[SymulationSpeedIndex];
						}
					}

					if (state.x > e.x1 && state.x<e.x2 && state.y>e.y1 && state.y < e.y2)
					{
						if (SymulationSpeedIndex > 0)
						{
							SymulationSpeedIndex--;
							SymulationSpeed = SymulationSpeedTab[SymulationSpeedIndex];
						}
					}
					cout << "Thread 2: Mouse Clicked" << endl;
					al_rest(0.25);
				}
			}
			else break;
		}
	}
};

struct Car
{
	int posX, posY;
	int Velocity;
	int MaxSpeed;
	int Lane;
	bool Omijam;
	bool Wpuscilem;
};

Car Cars[1000];

bool IfSomeoneOmija()
{
	for (int i = 0; i < CarsCount; i++)if (Cars[i].Omijam == true)return true;
	return false;
}

void DrawCar(int x, int y, int speed)
{
	int r, g, b;
	if (speed == 6) { r = 10; g = 10; b = 10; }
	if (abs(speed) == 0) { r = 128; g = 128; b = 128; }
	if (abs(speed) == 1) { r = 0; g = 255; b = 0; }
	else if (abs(speed) == 2) { r = 165; g = 255; b = 0; }
	else if (abs(speed) == 3) { r = 255; g = 255; b = 0; }
	else if (abs(speed) == 4) { r = 255; g = 165; b = 0; }
	else if (abs(speed) == 5) { r = 255; g = 0; b = 0; }
	al_draw_filled_rounded_rectangle( x-10, AnimatonPosY + y-6,  x+ 10, AnimatonPosY + y+6, 2,2, al_map_rgb(r,g,b));
}

void AddBlock(int y, int x)
{
	Cars[CarsCount].Velocity = 0;
	Cars[CarsCount].MaxSpeed = 0;
	Cars[CarsCount].posX = x;
	Cars[CarsCount].posY = y;
	Cars[CarsCount].Lane = y;
	Board[Cars[CarsCount].posY][Cars[CarsCount].posX] = 1;
	CarsCount++;
	BlockCount++;
};

int TextBox( int wsp_x, int wsp_y, size_t l_cyfr, int z_zachety, int nr_pola)
{
	al_draw_rectangle(wsp_x - 2, wsp_y - 2, wsp_x + 10 * l_cyfr + 2, wsp_y + 20, al_map_rgb(255, 255, 255), 1);	// obwodka pola tekstowego

	if ((state.x>wsp_x - 2 && state.x<wsp_x + 10 * l_cyfr) && (state.y>wsp_y - 2 && state.y<wsp_y + 20) && state.buttons == 1)
	{
		for (int i = 0; i<l_pol; i++)
		{
			przelacznik_t[i] = 0;
		}
		przelacznik_t[nr_pola] = 1;		//uaktywnienie pola, gdy kliknie sie na obszar pola
		al_rest(0.15);					// funkcja oczekujaca, gdy jej brak, warunek wykonuje sie wiele razy
	}

	if (przelacznik_t[nr_pola] == 1) 		// uaktywnione pole
	{
		//	al_draw_line(znak_zachety[nr_pola], wsp_y , znak_zachety[nr_pola], wsp_y + 16, al_map_rgba(255, 255, 255, 255), 1); // znak zachety
		al_draw_rectangle(wsp_x - 2, wsp_y - 2, wsp_x + 10 * l_cyfr + 2, wsp_y + 20, al_map_rgb(255, 255, 255), 3);	// obwodka pola tekstowego

		if (al_key_down(&klawiatura, ALLEGRO_KEY_1))	// warunek wcisnieca klawisza 1 (nad literami)
		{
			if (pole_t[nr_pola].length()<l_cyfr)		// sprawdzenie, czy dlugosc pola jest mniejsza, od zadeklarowanej liczby "cyfr"
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "1");	// wstawienie jedynki na koncu ciagu liczb																			// znak_zachety[nr_pola]-z_zachety/8 - dlugosc ciag																						// "1" - wstawienie jedynki na koncu ciagu 
				znak_zachety[nr_pola] += 8;											// zwiekszenie o 8 wspolrzednej x znaku_zachety danego pola 
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_2))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "2");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_3))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "3");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_4))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "4");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_5))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "5");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_6))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "6");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_7))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "7");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_8))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "8");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_9))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "9");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_0))
		{
			if (pole_t[nr_pola].length()<l_cyfr)
			{
				pole_t[nr_pola].insert((znak_zachety[nr_pola] - z_zachety) / 8, "0");
				znak_zachety[nr_pola] += 8;
				al_rest(0.15);
			}
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_BACKSPACE))										// klawisz backspace, nad enterem
		{
			if (pole_t[nr_pola].length()>0 && znak_zachety[nr_pola] != z_zachety)						// warunek usuwania znaku
																										// pole_t[nr_pola].length()>0, dlugosc ciagu znakow wiekszy od zera
																										// znak_zachety[nr_pola]!=z_zachety, polozenie znaku zachety rozne od poczatkowego
			{
				pole_t[nr_pola] = pole_t[nr_pola].erase(((znak_zachety[nr_pola] - z_zachety) / 8) - 1, 1);	// usuwanie ostatniego znaku
			}

			if (znak_zachety[nr_pola]>z_zachety + 7)													// gdy brak tego warunku, znak zachety moze opuscic obwodke pola
			{
				znak_zachety[nr_pola] -= 8;															// zmniejszenie o 8 wspolrzednej x znaku tekstowego danego pola
			}

			al_rest(0.15);
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_LEFT))			// lewa strzalka
		{
			if (znak_zachety[nr_pola]>z_zachety + 7)				// gdy brak tego warunku, znak zachety moze opuscic obwodke pola 
			{
				znak_zachety[nr_pola] -= 8;						// zmniejszenie o 8 wspolrzednej x znaku tekstowego danego pola
			}
			al_rest(0.15);
		}

		if (al_key_down(&klawiatura, ALLEGRO_KEY_RIGHT))						// prawa strzalka
		{
			if (znak_zachety[nr_pola]<z_zachety + 8 * pole_t[nr_pola].length())		// gdy brak tego warunku, znak zachety moze opuscic obwodke pola
			{
				znak_zachety[nr_pola] += 8;										// zwiekszenie o 8 wspolrzednej x znaku tekstowego danego pola
			}
			al_rest(0.15);
		}
	}
	al_draw_text(DigitFont, al_map_rgb(255, 255, 255), wsp_x, wsp_y - 2, 0, pole_t[nr_pola].c_str());	// wyswietlenie zawartosci danego pola na ekranie
	return atoi(pole_t[nr_pola].c_str());
}

bool IsSimulationRunning(void)
{
	int k = 0;
	for (int i = 0; i < 2; i++)for (int j = 0; j < 50; j++)if (Board[i][j] == 1 && j!=35)k++;
	if (k == 0) return 0;
	else return 1;
}

int main()
{
	// your test
	srand(time(NULL));
	al_init();
	al_init_primitives_addon();
	al_init_image_addon();
	al_init_font_addon();
	al_init_ttf_addon();
	al_install_keyboard();
	al_install_mouse();
	//ALLEGRO_KEYBOARD_STATE klawiatura;
	al_set_new_display_flags(ALLEGRO_WINDOWED);

	ALLEGRO_MOUSE_STATE state2;

	ALLEGRO_BITMAP  *grass = NULL;
	ALLEGRO_BITMAP  *bg = NULL;
	ALLEGRO_BITMAP  *cross = NULL;
	ALLEGRO_BITMAP  *zip = NULL;


	ALLEGRO_FONT *font1 = al_load_font(FontFile, 20, 0);
	ALLEGRO_FONT *font3 = al_load_font(FontFile, 50, 0);
	ALLEGRO_FONT *font2 = al_load_font(FontFile, 14, 0);
	DigitFont = al_load_font(DigitFontFile, 18, 0);

	ALLEGRO_DISPLAY *Window = al_create_display(1200, 750);
	al_set_window_title(Window, "Allegro5: Micha Jele - Two-way street Simulation");

	ALLEGRO_EVENT_QUEUE *event_queue = al_create_event_queue();
	al_register_event_source(event_queue, al_get_display_event_source(Window));
	ALLEGRO_EVENT event;

	Button ResetButton(560, 20, "RESET", font1);
	Button StartButton(710, 20, "START", font1);
	Button StopButton(860, 20, "STOP", font1);
	Button SpeedPlusButton(1010, 20, "SPEED+", font1);
	Button SpeedMinusButton(1010, 80, "SPEED-", font1);

	CheckMouse MouseClick(ResetButton, StopButton, StartButton, SpeedPlusButton, SpeedMinusButton);
	std::thread MouseClickThread(MouseClick);

	bg  = al_load_bitmap("bg.png");
	grass = al_load_bitmap("grass.png");
	cross = al_load_bitmap("cross.png");
	zip = al_load_bitmap("zip.png");

	przelacznik_t = new int[l_pol]; // deklaracja tablicy 
	for (int i = 0; i<l_pol; i++)przelacznik_t[i] = 0; // poczatkowo przelaczniki sa rowne 0 (pola sa nieaktywne)
	pole_t = new string[l_pol];
	znak_zachety = new int[l_pol];
	for (int i = 0; i<l_pol; i++)znak_zachety[i] = 25;		// przed petla while nalezy wypelnic tablice znak_zachety

	while (!al_key_down(&klawiatura, ALLEGRO_KEY_ENTER))
	{
		al_clear_to_color(al_map_rgb(0, 0, 0));
		al_draw_bitmap(bg, 0, 0, 0);
		al_draw_text(font3, al_map_rgb(255, 255, 255), 470, 100, ALLEGRO_ALIGN_LEFT, "SETTINGS");
		al_get_next_event(event_queue, &event);
		if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) return 0;
		al_get_mouse_state(&state);
		al_get_keyboard_state(&klawiatura);

		//al_clear_to_color(al_map_rgb(0, 0, 0));
		al_draw_text(font1, al_map_rgb(255, 255, 255), 450, 196, ALLEGRO_ALIGN_LEFT, "Cars count");
		MaxCarsCount = TextBox(600, 200, 10, 25, 0);
		al_draw_text(font1, al_map_rgb(255, 255, 255), 420, 246, ALLEGRO_ALIGN_LEFT, "Zipper method");
		Zamek = TextBox(600, 250, 10, 25, 1);
		//al_draw_text(font1, al_map_rgb(255, 255, 255),450, 246, ALLEGRO_ALIGN_LEFT, "Blocks count");
		//MaxBlockCount =TextBox( 600, 250, 10, 25, 1);

		al_draw_text(font1, al_map_rgb(255, 255, 255), 450, 700, ALLEGRO_ALIGN_LEFT, "Press Enter to start simulation");
		// wywolanie funkcji poletekstowe
		//poletekstowe(250, 25, 10, 25, 2);
		//poletekstowe(25, 250, 10, 25, 1);
		al_flip_display();
		//cout << MaxCarsCount;
		//al_show_native_message_box(Window,"Warning","Are you sure?","If you click yes then you are confirming that \"Yes\"""is your response to the query which you have""generated by the action you took to open this""message box.",NULL,ALLEGRO_MESSAGEBOX_OK_CANCEL);
	}
	MaxCarsCount -= 1;

Start:

	int LaneChoice = 0;		// Zmienna do losowania kierunku
	int Flag = 0;
	int Free = 0;    // Pomocniczna zmienna do zliczana wolnych miejsc przed samochodem
	int Time = 0;   //Zmienna liczaca 'czas' symulacji
	int CarInFrontOfSpeed = 0;
	int CarInFrontOfPosX = 0;
	SymulationTime = 0;
	int CarBehindSpeed = 0;
	int Token = 0;

	///////////////////////////// Inicjalizacja tablicy automatu komorkowego
	for (int i = 0; i < 2; i++)Board[i] = new int[50];
	for (int i = 0; i < 2; i++)for (int j = 0; j < 50; j++)Board[i][j] = 0;

	AddBlock(0, 35);

	while (1)
	{	
		Iteration++;
		if (Iteration>5 && !IsSimulationRunning())
		{ 
		ThreadOff = 1;
		string statistics;
		_itoa_s(SymulationTime, StatTime, 10);
		_itoa_s(MaxCarsCount+1, StatCar, 10);
		string time,cars,safedistance;
		time = "Simulation Time: ";time.append(StatTime);time.append(" ms\n");
		cars = "Cars generated : "; cars.append(StatCar); cars.append("\n");
		statistics.append(time);
		statistics.append(cars);	
		const char *c = statistics.c_str();
		al_show_native_message_box(Window, "Symulation Completed", "Simlation succefsully completed",c ,NULL , ALLEGRO_MESSAGEBOX_OK_CANCEL); 

		al_destroy_display(Window);
		al_destroy_bitmap(grass);
		al_destroy_bitmap(cross);
		al_destroy_font(font1);
		al_destroy_font(font2);
		al_destroy_font(font3);
		al_destroy_font(DigitFont);
		delete[] *Board;
		break;
		}

		if (Initialize == 1) { Initialize = 0; goto Start; }

		if (Stop == 0)
		{
			cout << "Thread 1: Symulation" << endl;
			al_flip_display();
			//if (Time == 3)CarsCount = 3;
			//if (Time == 11)Cars[1].Velocity = 3;	

			////////// Warunek tworzcy pojazdy
			if (Time%NewCarCreationTime == 0 && CarsCount <= MaxCarsCount)
			{

				/*
				LaneChoice = rand() % 2;
				if (LaneChoice == 0)Cars[CarsCount].posY = 0;
				else Cars[CarsCount].posY = 1;
				if (Board[Cars[CarsCount].posY][0] == 0)
				{
				Board[Cars[CarsCount].posY][0] = 1;
				Cars[CarsCount].posX = 0;
				Cars[CarsCount].MaxSpeed = rand() % MaxVelocity + 1;
				Cars[CarsCount].Velocity = rand() % Cars[CarsCount].MaxSpeed + 1;
				Cars[CarsCount].Wpuscilem = false;
				CarsCount++;
				}


				*/
				Cars[CarsCount].posY = 0;
				Board[Cars[CarsCount].posY][0] = 1;
				Cars[CarsCount].posX = 0;
				Cars[CarsCount].MaxSpeed = rand() % MaxVelocity + 1;
				Cars[CarsCount].Velocity = rand() % Cars[CarsCount].MaxSpeed + 1;
				Cars[CarsCount].Wpuscilem = false;
				CarsCount++;

				Cars[CarsCount].posY = 1;
				Board[Cars[CarsCount].posY][0] = 1;
				Cars[CarsCount].posX = 0;
				Cars[CarsCount].MaxSpeed = rand() % MaxVelocity + 1;
				Cars[CarsCount].Velocity = rand() % Cars[CarsCount].MaxSpeed + 1;
				Cars[CarsCount].Wpuscilem = false;
				CarsCount++;

			}

			/*
			system("cls");
			for (int j = 0; j < 50; j++) cout << Board[0][j];
			cout << endl;
			for (int j = 0; j < 50; j++) cout << Board[1][j];
			*/
			/*
			system("cls");
			for (int j = 0; j < 50; j++) cout << Board[2][j];
			cout << endl;
			for (int j = 0; j < 50; j++) cout << Board[3][j];
			cout << endl;
			*/
			/*
			cout << Cars[1].posX << " ";
			cout << Board[Cars[0].posY][Cars[0].posX + 1] << " " << Board[Cars[0].posY][Cars[0].posX + 2] << " " << Board[Cars[0].posY][Cars[0].posX + 3] << " " << Board[Cars[0].posY][Cars[0].posX + 4] << endl;
			cout << Cars[1].posY << " ";
			cout << Cars[1].Velocity << " ";
			cout << endl;
			cout << Cars[2].posX << " ";
			cout << Board[Cars[1].posY][Cars[1].posX + 1] << " " << Board[Cars[1].posY][Cars[1].posX + 2] << " " << Board[Cars[1].posY][Cars[1].posX + 3] << " " << Board[Cars[1].posY][Cars[1].posX + 4] << endl;
			cout << Cars[2].posY << " ";
			cout << Cars[2].Velocity << " ";
			cout << endl;
			*/

			// Brakes - Accelerate

			for (int k = 0; k < CarsCount; k++)
			{
				/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				/////////////////////////////////////////////////////////////////////////////////////////// Kierunek w PRAWO
				if (Cars[k].posY == 0 || Cars[k].posY == 1)
				{
					////////////////////// Change Lane
					if (Cars[k].MaxSpeed != 0 && Cars[k].Velocity == 0 && Board[Cars[k].posY][Cars[k].posX + 2] == 0 && Cars[k].posX == 34)
					{
						for (int l = 1; l <= Cars[k].MaxSpeed; l++)
						{
							if (Board[0][Cars[k].posX + l] == 1)
							{
								Free = 0;
								Token = 0;
								CarBehindSpeed = 0;

								for (int m = 1; m < MaxVelocity; m++)
								{
									if (Board[2 - Cars[k].posY - 1][Cars[k].posX - m] == 1)for (int p = 0; p < CarsCount; p++)if (Cars[p].posY == (2 - Cars[k].posY - 1) && Cars[p].posX == (Cars[k].posX - m)) { CarBehindSpeed = Cars[p].Velocity; break; break; }
								}

								for (int i = 0; i <= CarBehindSpeed; i++)
								{
									if (Board[2 - Cars[k].posY - 1][Cars[k].posX - i] == 0)Free++;
								}
								for (int i = 1; i <= FreeSpaceToChangeLane; i++) ///////////////////////// Czy mamy 2 wolne miejsca przed soba
								{
									if (Board[2 - Cars[k].posY - 1][Cars[k].posX + i] == 0)Token++;
								}


								if (Zamek == 0)
								{
									//cout << RandK << endl;
									//cout << Free << CarBehindSpeed + 1 << " "<< Token;
									if ((Free >= CarBehindSpeed + 1) && Token == FreeSpaceToChangeLane && Board[1][Cars[k].posX - 2] == 0 && Board[1][Cars[k].posX - 1] == 0 && Board[1][Cars[k].posX] == 0)
									{
										Board[Cars[k].posY][Cars[k].posX] = 0;
										Cars[k].posY = 2 - Cars[k].posY - 1;
										Cars[k].Velocity = 1;
										break;
									}

								}
								else
									if ((Free >= CarBehindSpeed) && Token == FreeSpaceToChangeLane && Board[1][Cars[k].posX] == 0)
									{
										Board[Cars[k].posY][Cars[k].posX] = 0;
										Cars[k].posY = 2 - Cars[k].posY - 1;
										Cars[k].Velocity = 1;
										break;
									}
							}
						}
						//if (CarBehindSpeed == 0)
						//{
						//		Board[Cars[k].posY][Cars[k].posX] = 0; 
						//		Cars[k].posY = 2 - Cars[k].posY - 1; 
						//		Cars[k].Velocity = 1;
						//	}
					}
					////////////////////////// Brakes

					for (int i = 1; i <= Cars[k].Velocity; i++)
					{

						if (Board[Cars[k].posY][Cars[k].posX + i] == 1 )
						{
							if (i == 1)
							{
								for (int l = 0; l < CarsCount; l++)if (Cars[l].posY == Cars[k].posY && Cars[l].posX == (Cars[k].posX + i)) { Cars[k].Velocity = Cars[l].Velocity; break; }
							}
							else
							{
								Cars[k].Velocity = i - 1;
								break;
							}
						}
					}

					////////////////////// Accelerate
					Token = 0;
					for (int i = 1; i <= FreeSpaceToAccelerate; i++)
					{
						if (Board[Cars[k].posY][Cars[k].posX + i] == 0)Token++;
					}
					if (Token >= FreeSpaceToAccelerate)if (Cars[k].Velocity < Cars[k].MaxSpeed)Cars[k].Velocity++;
					if (Board[Cars[k].posY][Cars[k].posX + 1] == 0 && Cars[k].Velocity == 0 && Cars[k].MaxSpeed != 0)Cars[k].Velocity = 1;
				}
			}
			//Symulacja
			for (int j = 0; j <= 24; j++)
			{
				//// Czyszczenie ekranu
				al_clear_to_color(al_map_rgb(0, 0, 0));

				///// Trawa
				al_draw_bitmap(grass, 0, 0, 0);
				al_draw_filled_rectangle(0, AnimatonPosY + 24, 840, AnimatonPosY + 24 + 46, al_map_rgb(0, 0, 0));
				al_draw_filled_rectangle(840, AnimatonPosY + 24+24, 1200, AnimatonPosY + 24 + 46, al_map_rgb(0, 0, 0));
				

				//// Symulacja samochodow
				for (int i = 0; i < CarsCount; i++)
				{
					DrawCar((Cars[i].posX * 24) + 12 + (j*Cars[i].Velocity), ((Cars[i].posY + 1) * 24) + 12, Cars[i].Velocity);
				}


				//////// GUI
				MouseClick.CheckButtons();
				if (MouseClick.a.Hover == 0)MouseClick.a.DrawButton();
				else MouseClick.a.DrawButtonHover();
			   
				if (MouseClick.b.Hover == 0)MouseClick.b.DrawButton();
				else MouseClick.b.DrawButtonHover();

				if (MouseClick.c.Hover == 0)MouseClick.c.DrawButton();
				else MouseClick.c.DrawButtonHover();

				if (MouseClick.d.Hover == 0)MouseClick.d.DrawButton();
				else MouseClick.d.DrawButtonHover();

				if (MouseClick.e.Hover == 0)MouseClick.e.DrawButton();
				else MouseClick.e.DrawButtonHover();

				
				//// Wypisz predkosc symulacji
				al_draw_text(font2, al_map_rgb(255, 255, 255),900 , 728, ALLEGRO_ALIGN_LEFT, "Symulation Speed");
				char str[3];
			    _itoa_s(SymulationSpeedIndex-3, str, 10);
				al_draw_textf(DigitFont, al_map_rgb(255, 255, 255),1150 , 726, ALLEGRO_ALIGN_LEFT,str );
				al_draw_text(font2, al_map_rgb(255, 255, 255), 1175, 728, ALLEGRO_ALIGN_LEFT, "x");


				////// Rysowanie przeszkod
				for (int i = 0; i < CarsCount; i++)
				{
					if (Cars[i].MaxSpeed == 0)al_draw_filled_rounded_rectangle(Cars[i].posX * 24 + 2, AnimatonPosY + (Cars[i].posY + 1) * 24 + 2, Cars[i].posX * 24 + 22, AnimatonPosY + (Cars[i].posY + 1) * 24 + 22, 2, 2, al_map_rgb(50, 50, 50));
				}

				//// Wyrysowanie pasow
			//	al_draw_filled_rounded_rectangle(840, 20 + AnimatonPosY, 1200, 46 + AnimatonPosY, 2, 2, al_map_rgb(0, 0, 0));
				al_draw_filled_triangle(840, AnimatonPosY + 23, 920, AnimatonPosY + 24 + 24, 840, AnimatonPosY + 24 + 24, al_map_rgb(0, 0, 0));
				al_draw_line(0, 24 + AnimatonPosY, 840, 24 + AnimatonPosY, al_map_rgb(255, 255, 255), 3);
				al_draw_line(840, 24 + AnimatonPosY, 920, 46 + AnimatonPosY, al_map_rgb(255, 255, 255), 3);
				for (int i = 0; i <= 90; i++)if (i % 2 == 0)al_draw_line(i * 10, 24 + 24 + AnimatonPosY, (i + 1) * 10, 24 + 24 + AnimatonPosY, al_map_rgb(255, 255, 255), 2);
				al_draw_line(920, 23 + 24 + AnimatonPosY, 1200, 23 + 24 + AnimatonPosY, al_map_rgb(255, 255, 255), 3);
				al_draw_line(0, 24 + 2 * 24 + AnimatonPosY, 1200, 24 + 2 * 24 + AnimatonPosY, al_map_rgb(255, 255, 255), 3);

				if(Zamek==1)al_draw_bitmap(zip,800,AnimatonPosY-100,  0);


				////// Rysowanie przeszkod
				//for (int i = 0; i <  BlockCount; i++)
				//{
				//	al_draw_filled_rounded_rectangle(Cars[i].posX * 24 + 2, AnimatonPosY + (Cars[i].posY + 1) * 24 + 2, Cars[i].posX * 24 + 22, AnimatonPosY + (Cars[i].posY + 1) * 24 + 22, 2, 2, al_map_rgb(50, 50, 50));
				//}


				//////// timer
				SymulationTime += 12;
				//std::cout << "Time: " << (std::clock() - start) / (double)(CLOCKS_PER_SEC / 1000) << " ms" << std::endl;
				al_draw_text(font2, al_map_rgb(255, 255, 255), 25, 728, ALLEGRO_ALIGN_LEFT, "Symulation Time :");
				_itoa_s(SymulationTime, str2, 10);
				al_draw_textf(DigitFont, al_map_rgb(255, 255, 255), 160, 726, ALLEGRO_ALIGN_LEFT, str2);
				al_draw_text(font2, al_map_rgb(255, 255, 255), 240, 728, ALLEGRO_ALIGN_LEFT, "ms");


				al_flip_display();   // Wrzucamy na screena
				al_rest(SymulationSpeed);		// Delay
			}

		

			// Poprawianie wartoci w tablicy
			for (int k = 0; k < CarsCount; k++)
			{
				Board[Cars[k].posY][Cars[k].posX] = 0;
				if (Cars[k].posX <= 50 && Cars[k].posX >= 0)Cars[k].posX += Cars[k].Velocity;
				Board[Cars[k].posY][Cars[k].posX] = 1;
			}
			Time++;
		
		}
		else
		{
			/////////////////// PAUSE
			al_draw_textf(font1, al_map_rgb(255, 255, 255) ,20, 20, ALLEGRO_ALIGN_LEFT, "Stopped");
		
			//al_get_next_event(event_queue, &event); if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) { allegro_exit(); return 0; 

			///////////// Usuwanie pojazdow + Dodawanie przeszkd
			al_get_mouse_state(&state2);

			if (state2.buttons & 2) {
				if (state2.y > AnimatonPosY + 25 && state2.y < AnimatonPosY + 75)
				{
					Board[((state2.y - AnimatonPosY) / 24) - 1][state2.x / 24] = 0;
					for (int i = 0; i < CarsCount; i++)
					{		
					if (Cars[i].posX == (state2.x / 24) && Cars[i].posY == (((state2.y - AnimatonPosY) / 24) - 1)) 
						{
							Cars[i].Velocity = 0;
							Cars[i].posX = 51;
							Cars[i].posY = 0;
							al_draw_bitmap(cross, (state2.x / 24 * 24), AnimatonPosY + (((state2.y - AnimatonPosY) / 24)) * 24, 0);
			
						}
					}
				}
			}

			if (state2.buttons & 1) {
				if (state2.y > AnimatonPosY + 24 && state2.y < AnimatonPosY + 72)
				{
					AddBlock( ((state2.y - AnimatonPosY) / 24) - 1, state2.x / 24);
					al_draw_filled_rounded_rectangle((state2.x / 24 * 24) +2, AnimatonPosY + (((state2.y - AnimatonPosY) / 24)) * 24 + 2, (state2.x / 24 * 24) + 22, AnimatonPosY + (((state2.y - AnimatonPosY) / 24)) * 24 + 22, 2, 2, al_map_rgb(50, 50, 50));					
				}

			}

			al_flip_display();
			al_rest(0.05);
			// in your event loop:
			al_register_event_source(event_queue, al_get_display_event_source(Window));
			if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) {
				return 0;
			}
		}
	}
	exit(EXIT_SUCCESS);
}